<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_17</title>
</head>
<body>
    <h1>Capitulo 17</h1>
    <a>Ejercicio 17</a>

    <script>

        const buscarCadenaPequ = (b,t) => {

            let m = new Array(256);

            for(let i = 0; i < 256; i++) {
                m[i] = 0;
            }

            let ans = Number.MAX_VALUE;
            let start = 0;
            let count = 0;
     
            for(let i = 0; i < t.length; i++) {
                if (m[t[i].charCodeAt(0)] == 0) {
                    count++;
                }
                m[t[i].charCodeAt(0)]++;
            }
  
            let i = 0;
            let j = 0;
  
            while (j < b.length) {
        
                m[b[j].charCodeAt(0)]--;
         
                if (m[b[j].charCodeAt(0)] == 0) {
                    count--;
                }
  
                if (count == 0) {
                    while (count == 0) {                

                        if (ans > j - i + 1) {
                            ans = Math.min(ans, j - i + 1);
                            start = i;
                        }
        
                        m[b[i].charCodeAt(0)]++;
                 
                        if (m[b[i].charCodeAt(0)] > 0) {
                            count++;
                        }
  
                        i++;
                    }
                }
                j++;
            }

            if (ans != Number.MAX_VALUE) {
                return (b).join("").substring(start, (start + ans));
            } else {
                return "-1";
            }
        }
 
        let b = "ADOBECODEBANC";
        let t = "ABC";
        console.log(`La cadena más pequeña que contiene "T" es: ${buscarCadenaPequ(b.split(""), t.split(""))} `);

    </script>
    
</body>
</html>